"""osinaweb URL Configuration

The `urlpatterns` list routes URLs to views. For more information please see:
    https://docs.djangoproject.com/en/4.1/topics/http/urls/
Examples:
Function views
    1. Add an import:  from my_app import views
    2. Add a URL to urlpatterns:  path('', views.home, name='home')
Class-based views
    1. Add an import:  from other_app.views import Home
    2. Add a URL to urlpatterns:  path('', Home.as_view(), name='home')
Including another URLconf
    1. Import the include() function: from django.urls import include, path
    2. Add a URL to urlpatterns:  path('blog/', include('blog.urls'))
"""

from django.urls import path, include
from support import views
from django.conf.urls.static import static
from django.conf import settings

urlpatterns = [
    path('add/', include('support.add.urls')),
    path('tickets/<str:ticket_number>/', views.ticket_room, name='ticketroom'),
    path('tickets/<str:ticket_number>/settings/', views.ticket_settings, name='ticketsettings'),


]

urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)